package org.myorg;
        
import java.io.IOException;
import java.util.*;
// import javax.imageio.ImageIO;
// import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.FileReader;
        
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.conf.*;
import org.apache.hadoop.io.*;
import org.apache.hadoop.mapred.*;
import org.apache.hadoop.util.*;
        
public class CellDetection {
        
 public static class Map extends MapReduceBase implements Mapper<LongWritable, Text, Text, Text> {
 
    private Text word = new Text();
        
    public void map(LongWritable key, Text value, OutputCollector<Text, Text> output, Reporter reporter) throws IOException {

		String exeCom = "../Research/DataSets/rhod74-10-/WBCdetect_PL"; 
		// String exeCom = "WBCdetect_PL";
        String line = value.toString();
		String data = "";
		
        StringTokenizer tokenizer = new StringTokenizer(line);
        while (tokenizer.hasMoreTokens()) {
			String im_name = tokenizer.nextToken();
            word.set(im_name);
			// BufferedImage image = null;
				
				String commandln = exeCom + " " + im_name;
				try {
				// Run image DETECTION
				Runtime rt  = Runtime.getRuntime();
				Process p = rt.exec(commandln);
				p.waitFor();	
				}
				catch (Exception exc) {
					System.out.println("ERROR: Calling EXE");
				}
				int l = im_name.length();
				int pos = l-4;
				try {
				String im_out_name = im_name.substring(0,pos) + ".txt";
				FileReader fr = new FileReader(im_out_name);
				BufferedReader br = new BufferedReader(fr);
				
				data = br.readLine();
				
				fr.close();
				}
				catch (IOException e) {
					 System.out.println("ERROR: IO ");
				}
				//Read image from a image file
				// File file =  new File(im_out_name);
				// image = ImageIO.read(file);
				
				//Read from an input stream
				// InputStream is = new BufferedInputStream( new FileInputStream(im_file));
				// image = ImageIO.read(is);
				
									

			
            output.collect(word, new Text(data));
			
        }
    }
 } 
        
 public static class Reduce extends MapReduceBase implements Reducer<Text, Text, Text, Text> {

    public void reduce(Text key, Iterator<Text> values, OutputCollector<Text, Text> output, Reporter reporter) throws IOException {
		String data= "";
        while (values.hasNext()) {
            data= values.next().toString();
        }
        output.collect(key, new Text(data));
    }
 }
        
 public static void main(String[] args) throws Exception {
    JobConf conf = new JobConf(CellDetection.class);
    conf.setJobName("celldetetion");
        
    conf.setOutputKeyClass(Text.class);
    conf.setOutputValueClass(Text.class);
        
    conf.setMapperClass(Map.class);
    conf.setReducerClass(Reduce.class);
        
    conf.setInputFormat(TextInputFormat.class);
    conf.setOutputFormat(TextOutputFormat.class);
        
    FileInputFormat.setInputPaths(conf, new Path(args[0]));
    FileOutputFormat.setOutputPath(conf, new Path(args[1]));
        
    JobClient.runJob(conf);
 }
        
}
